diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/bindings/modulegen__gcc_LP64.py ns-3.34/src/wimax/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/wimax/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -99,12 +99,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -176,7 +180,7 @@
     ## trace-helper.h (module 'network'): ns3::PcapHelper [class]
     module.add_class('PcapHelper', import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::PcapHelper::DataLinkType [enumeration]
-    module.add_enum('DataLinkType', ['DLT_NULL', 'DLT_EN10MB', 'DLT_PPP', 'DLT_RAW', 'DLT_IEEE802_11', 'DLT_LINUX_SLL', 'DLT_PRISM_HEADER', 'DLT_IEEE802_11_RADIO', 'DLT_IEEE802_15_4', 'DLT_NETLINK'], outer_class=root_module['ns3::PcapHelper'], import_from_module='ns.network')
+    module.add_enum('DataLinkType', ['DLT_NULL', 'DLT_EN10MB', 'DLT_PPP', 'DLT_RAW', 'DLT_IEEE802_11', 'DLT_LINUX_SLL', 'DLT_PRISM_HEADER', 'DLT_IEEE802_11_RADIO', 'DLT_IEEE802_15_4', 'DLT_NETLINK', 'DLT_LORATAP'], outer_class=root_module['ns3::PcapHelper'], import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::PcapHelperForDevice [class]
     module.add_class('PcapHelperForDevice', allow_subclassing=True, import_from_module='ns.network')
     ## snr-to-block-error-rate-manager.h (module 'wimax'): ns3::SNRToBlockErrorRateManager [class]
@@ -207,6 +211,10 @@
     module.add_class('Simulator', destructor_visibility='private', import_from_module='ns.core')
     ## simulator.h (module 'core'): ns3::Simulator [enumeration]
     module.add_enum('', ['NO_CONTEXT'], outer_class=root_module['ns3::Simulator'], import_from_module='ns.core')
+    ## ul-job.h (module 'wimax'): ns3::SortProcess [struct]
+    module.add_class('SortProcess')
+    ## ul-job.h (module 'wimax'): ns3::SortProcessPtr [struct]
+    module.add_class('SortProcessPtr')
     ## tag.h (module 'network'): ns3::Tag [class]
     module.add_class('Tag', import_from_module='ns.network', parent=root_module['ns3::ObjectBase'])
     ## tag-buffer.h (module 'network'): ns3::TagBuffer [class]
@@ -776,8 +784,10 @@
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3IpcsClassifierRecord_methods(root_module, root_module['ns3::IpcsClassifierRecord'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -811,6 +821,8 @@
     register_Ns3ServiceFlowRecord_methods(root_module, root_module['ns3::ServiceFlowRecord'])
     register_Ns3SimpleRefCount__Ns3Object_Ns3ObjectBase_Ns3ObjectDeleter_methods(root_module, root_module['ns3::SimpleRefCount< ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter >'])
     register_Ns3Simulator_methods(root_module, root_module['ns3::Simulator'])
+    register_Ns3SortProcess_methods(root_module, root_module['ns3::SortProcess'])
+    register_Ns3SortProcessPtr_methods(root_module, root_module['ns3::SortProcessPtr'])
     register_Ns3Tag_methods(root_module, root_module['ns3::Tag'])
     register_Ns3TagBuffer_methods(root_module, root_module['ns3::TagBuffer'])
     register_Ns3Time_methods(root_module, root_module['ns3::Time'])
@@ -2231,6 +2243,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2444,6 +2468,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2519,6 +2548,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2539,6 +2580,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -3738,26 +3784,26 @@
     cls.add_method('GetSigma2', 
                    'double', 
                    [])
-    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetBitErrorRate(double arg0) [member function]
+    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetBitErrorRate(double bitErrorRate) [member function]
     cls.add_method('SetBitErrorRate', 
                    'void', 
-                   [param('double', 'arg0')])
-    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetBlockErrorRate(double arg0) [member function]
+                   [param('double', 'bitErrorRate')])
+    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetBlockErrorRate(double blockErrorRate) [member function]
     cls.add_method('SetBlockErrorRate', 
                    'void', 
-                   [param('double', 'arg0')])
-    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetI1(double arg0) [member function]
+                   [param('double', 'blockErrorRate')])
+    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetI1(double i1) [member function]
     cls.add_method('SetI1', 
                    'void', 
-                   [param('double', 'arg0')])
-    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetI2(double arg0) [member function]
+                   [param('double', 'i1')])
+    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetI2(double i2) [member function]
     cls.add_method('SetI2', 
                    'void', 
-                   [param('double', 'arg0')])
-    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetSNRValue(double arg0) [member function]
+                   [param('double', 'i2')])
+    ## snr-to-block-error-rate-record.h (module 'wimax'): void ns3::SNRToBlockErrorRateRecord::SetSNRValue(double snrValue) [member function]
     cls.add_method('SetSNRValue', 
                    'void', 
-                   [param('double', 'arg0')])
+                   [param('double', 'snrValue')])
     return
 
 def register_Ns3SSRecord_methods(root_module, cls):
@@ -4602,6 +4648,30 @@
                    is_static=True)
     return
 
+def register_Ns3SortProcess_methods(root_module, cls):
+    ## ul-job.h (module 'wimax'): ns3::SortProcess::SortProcess() [constructor]
+    cls.add_constructor([])
+    ## ul-job.h (module 'wimax'): ns3::SortProcess::SortProcess(ns3::SortProcess const & arg0) [constructor]
+    cls.add_constructor([param('ns3::SortProcess const &', 'arg0')])
+    ## ul-job.h (module 'wimax'): bool ns3::SortProcess::operator()(ns3::PriorityUlJob & left, ns3::PriorityUlJob & right) const [member operator]
+    cls.add_method('operator()', 
+                   'bool', 
+                   [param('ns3::PriorityUlJob &', 'left'), param('ns3::PriorityUlJob &', 'right')], 
+                   custom_name='__call__', is_const=True)
+    return
+
+def register_Ns3SortProcessPtr_methods(root_module, cls):
+    ## ul-job.h (module 'wimax'): ns3::SortProcessPtr::SortProcessPtr() [constructor]
+    cls.add_constructor([])
+    ## ul-job.h (module 'wimax'): ns3::SortProcessPtr::SortProcessPtr(ns3::SortProcessPtr const & arg0) [constructor]
+    cls.add_constructor([param('ns3::SortProcessPtr const &', 'arg0')])
+    ## ul-job.h (module 'wimax'): bool ns3::SortProcessPtr::operator()(ns3::Ptr<ns3::PriorityUlJob> & left, ns3::Ptr<ns3::PriorityUlJob> & right) const [member operator]
+    cls.add_method('operator()', 
+                   'bool', 
+                   [param('ns3::Ptr< ns3::PriorityUlJob > &', 'left'), param('ns3::Ptr< ns3::PriorityUlJob > &', 'right')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Tag_methods(root_module, cls):
     ## tag.h (module 'network'): ns3::Tag::Tag() [constructor]
     cls.add_constructor([])
@@ -7960,10 +8030,10 @@
                    'uint32_t', 
                    [], 
                    is_virtual=True)
-    ## bs-uplink-scheduler-simple.h (module 'wimax'): void ns3::UplinkSchedulerSimple::GetChannelDescriptorsToUpdate(bool & arg0, bool & arg1, bool & arg2, bool & arg3) [member function]
+    ## bs-uplink-scheduler-simple.h (module 'wimax'): void ns3::UplinkSchedulerSimple::GetChannelDescriptorsToUpdate(bool & updateDcd, bool & updateUcd, bool & sendDcd, bool & sendUcd) [member function]
     cls.add_method('GetChannelDescriptorsToUpdate', 
                    'void', 
-                   [param('bool &', 'arg0'), param('bool &', 'arg1'), param('bool &', 'arg2'), param('bool &', 'arg3')], 
+                   [param('bool &', 'updateDcd'), param('bool &', 'updateUcd'), param('bool &', 'sendDcd'), param('bool &', 'sendUcd')], 
                    is_virtual=True)
     ## bs-uplink-scheduler-simple.h (module 'wimax'): static ns3::TypeId ns3::UplinkSchedulerSimple::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
@@ -12303,10 +12373,10 @@
                    'ns3::Ptr< ns3::BsServiceFlowManager >', 
                    [], 
                    is_const=True)
-    ## bs-net-device.h (module 'wimax'): void ns3::BaseStationNetDevice::SetServiceFlowManager(ns3::Ptr<ns3::BsServiceFlowManager> arg0) [member function]
+    ## bs-net-device.h (module 'wimax'): void ns3::BaseStationNetDevice::SetServiceFlowManager(ns3::Ptr<ns3::BsServiceFlowManager> sfm) [member function]
     cls.add_method('SetServiceFlowManager', 
                    'void', 
-                   [param('ns3::Ptr< ns3::BsServiceFlowManager >', 'arg0')])
+                   [param('ns3::Ptr< ns3::BsServiceFlowManager >', 'sfm')])
     ## bs-net-device.h (module 'wimax'): void ns3::BaseStationNetDevice::DoDispose() [member function]
     cls.add_method('DoDispose', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/examples/wimax-multicast.cc ns-3.34/src/wimax/examples/wimax-multicast.cc
--- ns-3.33/src/wimax/examples/wimax-multicast.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/examples/wimax-multicast.cc	2021-07-14 10:31:07.000000000 -0700
@@ -61,20 +61,18 @@
 #include "ns3/global-route-manager.h"
 #include "ns3/internet-module.h"
 #include "ns3/vector.h"
+#include <vector>
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("WimaxMulticastSimulation");
 
-#define MAXSS 1000
-#define MAXDIST 10 // km
-
 int main (int argc, char *argv[])
 {
   bool verbose = false;
 
   NodeContainer ssNodes;
-  Ptr<SubscriberStationNetDevice> ss[MAXSS];
+  std::vector<Ptr<SubscriberStationNetDevice> > ss;
   NetDeviceContainer ssDevs;
   Ipv4InterfaceContainer SSinterfaces;
 
@@ -83,8 +81,6 @@
   NetDeviceContainer bsDevs, bsDevsOne;
   Ipv4InterfaceContainer BSinterfaces;
 
-  UdpServerHelper udpServer[MAXSS];
-  ApplicationContainer serverApps[MAXSS];
   UdpTraceClientHelper udpClient;
   ApplicationContainer clientApps;
 
@@ -93,8 +89,8 @@
   NodeContainer ASNGW_Node;
 
   Ptr<ConstantPositionMobilityModel> BSPosition;
-  Ptr<RandomWaypointMobilityModel> SSPosition[MAXSS];
-  Ptr<RandomRectanglePositionAllocator> SSPosAllocator[MAXSS];
+  std::vector<Ptr<RandomWaypointMobilityModel> > SSPosition;
+  std::vector<Ptr<RandomRectanglePositionAllocator> > SSPosAllocator;
 
   // default values
   int nbSS = 10, duration = 7, schedType = 0;
@@ -125,6 +121,10 @@
       scheduler = WimaxHelper::SCHED_TYPE_SIMPLE;
     }
 
+  ss.resize (nbSS);
+  SSPosition.resize (nbSS);
+  SSPosAllocator.resize (nbSS);
+
   ssNodes.Create (nbSS);
   bsNodes.Create (1);
 
@@ -267,13 +267,11 @@
 
   uint16_t multicast_port = 100;
 
-  for (int i = 0; i < nbSS; i++)
-    {
-      udpServer[i] = UdpServerHelper (multicast_port);
-      serverApps[i] = udpServer[i].Install (ssNodes.Get (i));
-      serverApps[i].Start (Seconds (6));
-      serverApps[i].Stop (Seconds (duration));
-    }
+  UdpServerHelper udpServerHelper = UdpServerHelper (multicast_port);
+  ApplicationContainer serverApps;
+  serverApps = udpServerHelper.Install (ssNodes);
+  serverApps.Start (Seconds (6));
+  serverApps.Stop (Seconds (duration));
 
   udpClient = UdpTraceClientHelper (multicastGroup, multicast_port, "");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/bs-net-device.h ns-3.34/src/wimax/model/bs-net-device.h
--- ns-3.33/src/wimax/model/bs-net-device.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/bs-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -282,8 +282,9 @@
   Ptr<BsServiceFlowManager> GetServiceFlowManager (void) const;
   /**
    * \brief Set service flow manager
+   * \param sfm the service flow manager
    */
-  void SetServiceFlowManager (Ptr<BsServiceFlowManager> );
+  void SetServiceFlowManager (Ptr<BsServiceFlowManager> sfm);
 private:
   virtual void DoDispose (void);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/bs-uplink-scheduler-simple.h ns-3.34/src/wimax/model/bs-uplink-scheduler-simple.h
--- ns-3.33/src/wimax/model/bs-uplink-scheduler-simple.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/bs-uplink-scheduler-simple.h	2021-07-14 10:31:07.000000000 -0700
@@ -60,8 +60,14 @@
   /**
    * \brief Determines if channel descriptors sent in the current frame are
    * required to be updated
+   *
+   * \param updateDcd currently unused (assume true)
+   * \param updateUcd currently unused (assume true)
+   * \param [out] sendDcd DCD must be updated
+   * \param [out] sendUcd UCD must be updated
+   *
    */
-  void GetChannelDescriptorsToUpdate (bool&, bool&, bool&, bool&);
+  void GetChannelDescriptorsToUpdate (bool& updateDcd, bool& updateUcd, bool& sendDcd, bool& sendUcd);
   uint32_t CalculateAllocationStartTime (void);
   void AddUplinkAllocation (OfdmUlMapIe &ulMapIe,
                             const uint32_t &allocationSize,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/snr-to-block-error-rate-record.cc ns-3.34/src/wimax/model/snr-to-block-error-rate-record.cc
--- ns-3.33/src/wimax/model/snr-to-block-error-rate-record.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/snr-to-block-error-rate-record.cc	2021-07-14 10:31:07.000000000 -0700
@@ -103,14 +103,14 @@
   m_blockErrorRate = blockErrorRate;
 }
 void
-SNRToBlockErrorRateRecord::SetI1 (double I1)
+SNRToBlockErrorRateRecord::SetI1 (double i1)
 {
-  m_i1 = I1;
+  m_i1 = i1;
 }
 void
-SNRToBlockErrorRateRecord::SetI2 (double I2)
+SNRToBlockErrorRateRecord::SetI2 (double i2)
 {
-  m_i2 = I2;
+  m_i2 = i2;
 }
 
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/snr-to-block-error-rate-record.h ns-3.34/src/wimax/model/snr-to-block-error-rate-record.h
--- ns-3.33/src/wimax/model/snr-to-block-error-rate-record.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/snr-to-block-error-rate-record.h	2021-07-14 10:31:07.000000000 -0700
@@ -80,24 +80,29 @@
 
   /**
    * \brief set the snr value
+   * \param snrValue the SNR value
    */
-  void SetSNRValue (double);
+  void SetSNRValue (double snrValue);
   /**
    * \brief set the BER value
+   * \param bitErrorRate the bit error rate value
    */
-  void SetBitErrorRate (double);
+  void SetBitErrorRate (double bitErrorRate);
   /**
    * \brief set the BlcER value
+   * \param blockErrorRate the block error rate value
    */
-  void SetBlockErrorRate (double);
+  void SetBlockErrorRate (double blockErrorRate);
   /**
    * \brief set the lower boundary of the confidence interval
+   * \param i1 the lower boundary of the confidence interval
    */
-  void SetI1 (double);
+  void SetI1 (double i1);
   /**
    * \brief set the upper boundary of the confidence interval
+   * \param i2 the upper boundary of the confidence interval
    */
-  void SetI2 (double);
+  void SetI2 (double i2);
 
 private:
   double m_snrValue; ///< SNR value
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/ss-service-flow-manager.h ns-3.34/src/wimax/model/ss-service-flow-manager.h
--- ns-3.33/src/wimax/model/ss-service-flow-manager.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/ss-service-flow-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -50,13 +50,11 @@
     CONFIRMATION_CODE_REJECT
   };
   /**
-   * \brief creates a service flow manager and attaches it to a device
-   * \param  device the device to which the service flow manager will be attached
-   */
-  /**
    * Constructor
    *
-   * \param device subscriber station device
+   * Creates a service flow manager and attaches it to a device
+   *
+   * \param device the device to which the service flow manager will be attached
    */
   SsServiceFlowManager (Ptr<SubscriberStationNetDevice> device);
   ~SsServiceFlowManager (void);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wimax/model/ul-job.h ns-3.34/src/wimax/model/ul-job.h
--- ns-3.33/src/wimax/model/ul-job.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wimax/model/ul-job.h	2021-07-14 10:31:07.000000000 -0700
@@ -202,7 +202,7 @@
 };
 
 /// SortProcess structure 
-struct SortProcess : public std::binary_function<PriorityUlJob*, PriorityUlJob*, bool>
+struct SortProcess
 {
   /**
    * \brief comparison operator
@@ -237,7 +237,7 @@
 };
 
 /// SortProcessPtr structure
-struct SortProcessPtr: public std::binary_function< Ptr<PriorityUlJob>, Ptr<PriorityUlJob>, bool>
+struct SortProcessPtr
 {
   /**
    * \brief comparison operator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wscript ns-3.34/src/wscript
--- ns-3.33/src/wscript	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -40,12 +40,11 @@
                          " --run and --shell; moreover, only works in some"
                          " specific platforms, such as Linux and Solaris)"),
                    action="store_true", dest='enable_rpath', default=False)
-    
+
     opt.add_option('--enable-modules',
                    help=("Build only these modules (and dependencies)"),
                    dest='enable_modules')
 
-    opt.load('boost', tooldir=['waf-tools'])
 
     for module in all_modules:
         opt.recurse(module, mandatory=False)
@@ -110,7 +109,7 @@
     module.is_static = static
     module.vnum = wutils.VNUM
     # Add the proper path to the module's name.
-    # Set the libraries this module depends on.  
+    # Set the libraries this module depends on.
     module.module_deps = list(dependencies)
 
     module.install_path = "${LIBDIR}"
@@ -129,7 +128,7 @@
     
     module.pcfilegen = bld(features='ns3pcfile')
     module.pcfilegen.module = module.name
-    
+
     return module
 
 @TaskGen.feature("ns3testlib")
@@ -157,7 +156,7 @@
     # Add this module and test library to the list.
     bld.env.append_value('NS3_MODULES_WITH_TEST_LIBRARIES', [(library.module_name, library.name)])
 
-    # Set the include path from the build directory to modules. 
+    # Set the include path from the build directory to modules.
     relative_path_from_build_to_here = bld.path.path_from(bld.bldnode)
     include_flag = '-I' + relative_path_from_build_to_here
     library.env.append_value('CXXFLAGS', include_flag)
@@ -235,7 +234,7 @@
             '${PYTHON}']
     #if debug:
     #    argv.extend(["-m", "pdb"])
-    
+
     argv.extend(['${SRC[0]}', module_abs_src_path, apidefs, extension_name, '${TGT[0]}'])
 
     argv.extend(['2>', '${TGT[2]}']) # 2> ns3modulegen.log
@@ -278,6 +277,7 @@
             pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
     defines = list(pymod.env['DEFINES'])
     defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_34=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_32=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_31=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_30=', 'NS3_DEPRECATED_H'])
@@ -292,12 +292,6 @@
     pymod.includes = Context.out_dir + ' ' + Context.out_dir + '/src/core/bindings'
     pymod.install_path = '${PYTHONARCHDIR}/ns'
 
-    # Workaround to a WAF bug, remove this when ns-3 upgrades to WAF > 1.6.10
-    # https://www.nsnam.org/bugzilla/show_bug.cgi?id=1335
-    # http://code.google.com/p/waf/issues/detail?id=1098
-    if Utils.unversioned_sys_platform() == 'darwin':
-        pymod.mac_bundle = True
-
     return pymod
 
 
@@ -306,7 +300,7 @@
     bld.create_ns3_module_test_library = types.MethodType(create_ns3_module_test_library, bld)
     bld.create_obj = types.MethodType(create_obj, bld)
     bld.ns3_python_bindings = types.MethodType(ns3_python_bindings, bld)
-    
+
     # Remove these modules from the list of all modules.
     for not_built in bld.env['MODULES_NOT_BUILT']:
 
@@ -378,14 +372,13 @@
         return self._listify(self.env['CXXFLAGS_%s' % dep])
 
     def _defines(self, dep):
-        return [self.env['DEFINES_ST'] % define for define in self.env['DEFINES_%s' % dep]] 
+        return [self.env['DEFINES_ST'] % define for define in self.env['DEFINES_%s' % dep]]
 
     def _includes(self, dep):
         includes = self.env['INCLUDES_%s' % dep]
         return [self.env['CPPPATH_ST'] % include for include in Utils.to_list(includes)]
 
     def _generate_pcfile(self, name, use, env, outfilename, module):
-        outfile = open(outfilename, 'wt')
         prefix = env.PREFIX
         includedir = Utils.subst_vars('${INCLUDEDIR}/%s%s' % (wutils.APPNAME, wutils.VERSION), env)
         libdir = env.LIBDIR
@@ -406,7 +399,9 @@
             if dep.startswith('ns3-'):
                 dep_name = dep[4:]
                 requires.append("libns%s-%s%s" % (wutils.VERSION, dep_name, env.BUILD_SUFFIX))
-        print("""\
+
+        with open(outfilename, 'wt') as outfile:
+            print("""\
 prefix=%s
 libdir=%s
 includedir=%s
@@ -419,11 +414,10 @@
 Requires: %s\
 """ % (prefix, libdir, includedir,
        name, name, wutils.VERSION, ' '.join(libs), ' '.join(cflags), ' '.join(requires)), file=outfile)
-        outfile.close()
 
     def run(self):
         output_filename = self.outputs[0].abspath()
-        self._generate_pcfile(self.module.name, 
+        self._generate_pcfile(self.module.name,
                               self.module.to_list(self.module.use),
                               self.env, output_filename, self.module)
 
@@ -666,10 +660,10 @@
         assert len(self.outputs) == 1
         out_file_name = self.outputs[0].get_bld().abspath()#self.env)
         header_files = [os.path.basename(node.abspath()) for node in self.inputs]
-        outfile = open(out_file_name, "w")
         header_files.sort()
 
-        print("""
+        with open(out_file_name, "w") as outfile:
+            print("""
 #ifdef NS3_MODULE_COMPILATION
 # error "Do not include ns3 module aggregator headers from other modules; these are meant only for end user scripts."
 #endif
@@ -682,14 +676,13 @@
     #     for dep in self.module_deps:
     #         print >> outfile, "#include \"%s-module.h\"" % dep
 
-        print(file=outfile)
-        print("// Module headers:", file=outfile)
-        for header in header_files:
-            print("#include \"%s\"" % (header,), file=outfile)
+            print(file=outfile)
+            print("// Module headers:", file=outfile)
+            for header in header_files:
+                print("#include \"%s\"" % (header,), file=outfile)
 
-        print("#endif", file=outfile)
+            print("#endif", file=outfile)
 
-        outfile.close()
         return 0
 
     def sig_explicit_deps(self):
